From 4c302f95d0a8797ec53addc8fb48af381f8db2d4 Mon Sep 17 00:00:00 2001
From: Ayrat Badykov <ayratin555@gmail.com>
Date: Sat, 15 Feb 2020 13:21:18 +0300
Subject: [PATCH 2/2] fix tests

---
 .../runner/address/token_balances_test.exs    |  8 +++++--
 .../test/explorer/chain/import_test.exs       | 16 ++++++++-----
 .../explorer/token/balance_reader_test.exs    |  6 +++--
 apps/explorer/test/support/factory.ex         |  3 ++-
 apps/indexer/lib/indexer/token_balances.ex    |  2 ++
 .../indexer/fetcher/token_balance_test.exs    | 24 +++++++++++++------
 .../test/indexer/token_balances_test.exs      |  8 +++++--
 .../transform/address_token_balances_test.exs | 11 ++++++---
 .../transform/token_transfers_test.exs        |  8 ++-----
 9 files changed, 57 insertions(+), 29 deletions(-)

diff --git a/apps/explorer/test/explorer/chain/import/runner/address/token_balances_test.exs b/apps/explorer/test/explorer/chain/import/runner/address/token_balances_test.exs
index a40cd8599..533d1a029 100644
--- a/apps/explorer/test/explorer/chain/import/runner/address/token_balances_test.exs
+++ b/apps/explorer/test/explorer/chain/import/runner/address/token_balances_test.exs
@@ -29,7 +29,9 @@ defmodule Explorer.Chain.Import.Runner.Address.TokenBalancesTest do
         block_number: block_number,
         token_contract_address_hash: token_contract_address_hash,
         value: value,
-        value_fetched_at: value_fetched_at
+        value_fetched_at: value_fetched_at,
+        token_id: 11,
+        token_type: "ERC-20"
       }
 
       assert {:ok,
@@ -69,7 +71,9 @@ defmodule Explorer.Chain.Import.Runner.Address.TokenBalancesTest do
         block_number: block_number,
         token_contract_address_hash: token_contract_address_hash,
         value: nil,
-        value_fetched_at: value_fetched_at
+        value_fetched_at: value_fetched_at,
+        token_id: 11,
+        token_type: "ERC-20"
       }
 
       assert {:ok,
diff --git a/apps/explorer/test/explorer/chain/import_test.exs b/apps/explorer/test/explorer/chain/import_test.exs
index 7a06fa277..97dc79a65 100644
--- a/apps/explorer/test/explorer/chain/import_test.exs
+++ b/apps/explorer/test/explorer/chain/import_test.exs
@@ -384,17 +384,20 @@ defmodule Explorer.Chain.ImportTest do
             %{
               address_hash: "0xe8ddc5c7a2d2f0d7a9798459c0104fdf5e987aca",
               token_contract_address_hash: "0x8bf38d4764929064f2d4d3a56520a76ab3df415b",
-              block_number: "37"
+              block_number: "37",
+              token_type: "ERC-20"
             },
             %{
               address_hash: "0x515c09c5bba1ed566b02a5b0599ec5d5d0aee73d",
               token_contract_address_hash: "0x8bf38d4764929064f2d4d3a56520a76ab3df415b",
-              block_number: "37"
+              block_number: "37",
+              token_type: "ERC-20"
             },
             %{
               address_hash: "0x8bf38d4764929064f2d4d3a56520a76ab3df415b",
               token_contract_address_hash: "0x8bf38d4764929064f2d4d3a56520a76ab3df415b",
-              block_number: "37"
+              block_number: "37",
+              token_type: "ERC-20"
             }
           ],
           timeout: 5
@@ -1483,8 +1486,8 @@ defmodule Explorer.Chain.ImportTest do
                  },
                  address_coin_balances: %{
                    params: [
-                     %{address_hash: miner_hash, block_number: block_number, value: nil},
-                     %{address_hash: uncle_miner_hash, block_number: block_number, value: nil}
+                     %{address_hash: miner_hash, block_number: block_number, value: nil, token_type: "ERC-20"},
+                     %{address_hash: uncle_miner_hash, block_number: block_number, value: nil, token_type: "ERC-20"}
                    ],
                    timeout: 1
                  },
@@ -2050,7 +2053,8 @@ defmodule Explorer.Chain.ImportTest do
                        address_hash: address_hash,
                        token_contract_address_hash: token_contract_address_hash,
                        block_number: block_number,
-                       value: value_after
+                       value: value_after,
+                       token_type: "ERC-20"
                      }
                    ]
                  },
diff --git a/apps/explorer/test/explorer/token/balance_reader_test.exs b/apps/explorer/test/explorer/token/balance_reader_test.exs
index 871c688a7..5dc3510b8 100644
--- a/apps/explorer/test/explorer/token/balance_reader_test.exs
+++ b/apps/explorer/test/explorer/token/balance_reader_test.exs
@@ -32,7 +32,8 @@ defmodule Explorer.Token.BalanceReaderTest do
           %{
             token_contract_address_hash: token_contract_address_hash,
             address_hash: address_hash,
-            block_number: block_number
+            block_number: block_number,
+            token_type: "ERC-20"
           }
         ])
 
@@ -51,7 +52,8 @@ defmodule Explorer.Token.BalanceReaderTest do
           %{
             token_contract_address_hash: token_contract_address_hash,
             address_hash: address_hash,
-            block_number: block_number
+            block_number: block_number,
+            token_type: "ERC-20"
           }
         ])
 
diff --git a/apps/explorer/test/support/factory.ex b/apps/explorer/test/support/factory.ex
index 668d5fa6f..64ab19d23 100644
--- a/apps/explorer/test/support/factory.ex
+++ b/apps/explorer/test/support/factory.ex
@@ -571,7 +571,8 @@ defmodule Explorer.Factory do
       token_contract_address_hash: insert(:token).contract_address_hash,
       block_number: block_number(),
       value: Enum.random(1..100_000),
-      value_fetched_at: DateTime.utc_now()
+      value_fetched_at: DateTime.utc_now(),
+      token_type: "ERC-20"
     }
   end
 
diff --git a/apps/indexer/lib/indexer/token_balances.ex b/apps/indexer/lib/indexer/token_balances.ex
index ebec3d34a..22dabab2f 100644
--- a/apps/indexer/lib/indexer/token_balances.ex
+++ b/apps/indexer/lib/indexer/token_balances.ex
@@ -26,6 +26,8 @@ defmodule Indexer.TokenBalances do
   * `token_contract_address_hash` - The contract address that represents the Token in the blockchain.
   * `address_hash` - The address_hash that we want to know the balance.
   * `block_number` - The block number that the address_hash has the balance.
+  * `token_type` - type of the token that balance belongs to
+  * `token_id` - token id for ERC-1155 tokens
   """
   def fetch_token_balances_from_blockchain([]), do: {:ok, []}
 
diff --git a/apps/indexer/test/indexer/fetcher/token_balance_test.exs b/apps/indexer/test/indexer/fetcher/token_balance_test.exs
index 2ecee3eac..a9c3c6284 100644
--- a/apps/indexer/test/indexer/fetcher/token_balance_test.exs
+++ b/apps/indexer/test/indexer/fetcher/token_balance_test.exs
@@ -23,7 +23,7 @@ defmodule Indexer.Fetcher.TokenBalanceTest do
       insert(:token_balance, value_fetched_at: DateTime.utc_now())
 
       assert TokenBalance.init([], &[&1 | &2], nil) == [
-               {address_hash_bytes, token_contract_address_hash_bytes, block_number, 0}
+               {address_hash_bytes, token_contract_address_hash_bytes, 1000, "ERC-20", nil, 0}
              ]
     end
   end
@@ -58,7 +58,7 @@ defmodule Indexer.Fetcher.TokenBalanceTest do
       )
 
       assert TokenBalance.run(
-               [{address_hash_bytes, token_contract_address_hash_bytes, block_number, 0}],
+               [{address_hash_bytes, token_contract_address_hash_bytes, block_number, "ERC-20", nil, 0}],
                nil
              ) == :ok
 
@@ -96,6 +96,8 @@ defmodule Indexer.Fetcher.TokenBalanceTest do
         {
           token_balance_a.address_hash.bytes,
           token_balance_a.token_contract_address_hash.bytes,
+          "ERC-20",
+          nil,
           token_balance_a.block_number,
           # this token balance must be ignored
           max_retries
@@ -103,6 +105,8 @@ defmodule Indexer.Fetcher.TokenBalanceTest do
         {
           token_balance_b.address_hash.bytes,
           token_balance_b.token_contract_address_hash.bytes,
+          "ERC-20",
+          nil,
           token_balance_b.block_number,
           # this token balance still have to be retried
           max_retries - 2
@@ -136,8 +140,8 @@ defmodule Indexer.Fetcher.TokenBalanceTest do
 
       assert TokenBalance.run(
                [
-                 {address_hash_bytes, token_contract_address_hash_bytes, block_number, 0},
-                 {address_hash_bytes, token_contract_address_hash_bytes, block_number, 0}
+                 {address_hash_bytes, token_contract_address_hash_bytes, block_number, "ERC-20", nil, 0},
+                 {address_hash_bytes, token_contract_address_hash_bytes, block_number, "ERC-20", nil, 0}
                ],
                nil
              ) == :ok
@@ -177,7 +181,9 @@ defmodule Indexer.Fetcher.TokenBalanceTest do
         %{
           address_hash: "0xFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
           block_number: 19999,
-          token_contract_address_hash: to_string(contract.contract_address_hash)
+          token_contract_address_hash: to_string(contract.contract_address_hash),
+          token_type: "ERC-20",
+          token_id: nil
         }
       ]
 
@@ -195,12 +201,16 @@ defmodule Indexer.Fetcher.TokenBalanceTest do
         %{
           address_hash: "0xFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
           block_number: 19999,
-          token_contract_address_hash: to_string(contract.contract_address_hash)
+          token_contract_address_hash: to_string(contract.contract_address_hash),
+          token_id: 11,
+          token_type: "ERC-20"
         },
         %{
           address_hash: "0xFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
           block_number: 19999,
-          token_contract_address_hash: to_string(contract2.contract_address_hash)
+          token_contract_address_hash: to_string(contract2.contract_address_hash),
+          token_id: 11,
+          token_type: "ERC-20"
         }
       ]
 
diff --git a/apps/indexer/test/indexer/token_balances_test.exs b/apps/indexer/test/indexer/token_balances_test.exs
index 6c2eccf37..33ad0aba9 100644
--- a/apps/indexer/test/indexer/token_balances_test.exs
+++ b/apps/indexer/test/indexer/token_balances_test.exs
@@ -29,7 +29,9 @@ defmodule Indexer.TokenBalancesTest do
       data = %{
         token_contract_address_hash: Hash.to_string(token.contract_address_hash),
         address_hash: address_hash_string,
-        block_number: 1_000
+        block_number: 1_000,
+        token_id: 11,
+        token_type: "ERC-20"
       }
 
       get_balance_from_blockchain()
@@ -54,7 +56,9 @@ defmodule Indexer.TokenBalancesTest do
           address_hash: to_string(address.hash),
           block_number: 1_000,
           token_contract_address_hash: to_string(token.contract_address_hash),
-          retries_count: 1
+          retries_count: 1,
+          token_id: 11,
+          token_type: "ERC-20"
         }
       ]
 
diff --git a/apps/indexer/test/indexer/transform/address_token_balances_test.exs b/apps/indexer/test/indexer/transform/address_token_balances_test.exs
index 1e2269655..82009ffab 100644
--- a/apps/indexer/test/indexer/transform/address_token_balances_test.exs
+++ b/apps/indexer/test/indexer/transform/address_token_balances_test.exs
@@ -24,7 +24,9 @@ defmodule Indexer.Transform.AddressTokenBalancesTest do
         block_number: block_number,
         from_address_hash: from_address_hash,
         to_address_hash: to_address_hash,
-        token_contract_address_hash: token_contract_address_hash
+        token_contract_address_hash: token_contract_address_hash,
+        token_id: nil,
+        token_type: "ERC-20"
       }
 
       params_set = AddressTokenBalances.params_set(%{token_transfers_params: [token_transfer_params]})
@@ -46,7 +48,8 @@ defmodule Indexer.Transform.AddressTokenBalancesTest do
         from_address_hash: from_address_hash,
         to_address_hash: to_address_hash,
         token_contract_address_hash: token_contract_address_hash,
-        token_type: "ERC-721"
+        token_type: "ERC-721",
+        token_id: nil
       }
 
       params_set = AddressTokenBalances.params_set(%{token_transfers_params: [token_transfer_params]})
@@ -56,7 +59,9 @@ defmodule Indexer.Transform.AddressTokenBalancesTest do
                  %{
                    address_hash: "0x5b8410f67eb8040bb1cd1e8a4ff9d5f6ce678a15",
                    block_number: 1,
-                   token_contract_address_hash: "0xe18035bf8712672935fdb4e5e431b1a0183d2dfc"
+                   token_contract_address_hash: "0xe18035bf8712672935fdb4e5e431b1a0183d2dfc",
+                   token_id: nil,
+                   token_type: "ERC-721"
                  }
                ])
     end
diff --git a/apps/indexer/test/indexer/transform/token_transfers_test.exs b/apps/indexer/test/indexer/transform/token_transfers_test.exs
index 700929548..433c0e2c4 100644
--- a/apps/indexer/test/indexer/transform/token_transfers_test.exs
+++ b/apps/indexer/test/indexer/transform/token_transfers_test.exs
@@ -198,18 +198,14 @@ defmodule Indexer.Transform.TokenTransfersTest do
                    log_index: 2,
                    to_address_hash: "0x6c943470780461b00783ad530a53913bd2c104d3",
                    token_contract_address_hash: "0x58Ab73CB79c8275628E0213742a85B163fE0A9Fb",
+                   token_id: nil,
                    token_ids: [680_564_733_841_876_926_926_749_214_863_536_422_912],
                    token_type: "ERC-1155",
                    transaction_hash: "0x6d2dd62c178e55a13b65601f227c4ffdd8aa4e3bcb1f24731363b4f7619e92c8",
                    values: [5000]
                  }
                ],
-               tokens: [
-                 %{
-                   contract_address_hash: "0x58Ab73CB79c8275628E0213742a85B163fE0A9Fb",
-                   type: "ERC-1155"
-                 }
-               ]
+               tokens: [%{contract_address_hash: "0x58Ab73CB79c8275628E0213742a85B163fE0A9Fb", type: "ERC-1155"}]
              }
     end
 
-- 
2.30.1 (Apple Git-130)

